
#ifndef DI_THIS
#define DI_THIS

//Create by MKTMK. Moscow, Russia v1.01 24.oct.2003 (Last modif. 14.aug.2004)
//distributed under the GNU LGPL

//unsigned digit integer of any length 
//define operation &,|,&=,|=,=,==,!=,<,>,<=,>=,cast to (store unit*),~
//define operation ^,^=,<<,>>,<<=,>>=
//define operation +=,-=,++ and --(postf. and pref.)
//define operation *=,/=,%=,+,-,*,/,%
//may be use for operation and store big digit i.e. factorial
//may be use for emulation register any length
//may be use for indication error by position code
//if many number of error is present
//or other legal purpose
//this code do not use new  and delete operators
//this code do not use any exception by default
//this code use exception "divide by zero" only if user enable it
//this code do not use BC, MS, GCC and other extension and #pragma directive
//this code do not use API of any OS. Only pure C++.
//this code may be use in multithread system

//some user macros for behaviour control:

//if define this macro, divide by zero exception enable
//#define DI_EXCEPTIONENABLE

class di_exception{
public:
di_exception(){}
};

#include <limits.h>
#include <stddef.h>

#ifndef DI_INLINE
#define DI_INLINE inline
#endif

typedef unsigned int di_version;
const di_version DI_VERSION=101;
typedef unsigned long int di_serialnumber;
const di_serialnumber DI_SN=101;

inline bool di_char2byte(const unsigned char c,unsigned char* b){
bool r=true;;
switch(c){
case '0':*b=0;break;
case '1':*b=1;break;
case '2':*b=2;break;
case '3':*b=3;break;
case '4':*b=4;break;
case '5':*b=5;break;
case '6':*b=6;break;
case '7':*b=7;break;
case '8':*b=8;break;
case '9':*b=9;break;
case 'A':case 'a':*b=10;break;
case 'B':case 'b':*b=11;break;
case 'C':case 'c':*b=12;break;
case 'D':case 'd':*b=13;break;
case 'E':case 'e':*b=14;break;
case 'F':case 'f':*b=15;break;
default:r=false;break;
}//switch
return r;
}

inline unsigned char di_byte2char(const unsigned char b){
unsigned char c;
switch(b){
case 0:c='0';break;
case 1:c='1';break;
case 2:c='2';break;
case 3:c='3';break;
case 4:c='4';break;
case 5:c='5';break;
case 6:c='6';break;
case 7:c='7';break;
case 8:c='8';break;
case 9:c='9';break;
case 10:c='a';break;
case 11:c='b';break;
case 12:c='c';break;
case 13:c='d';break;
case 14:c='e';break;
case 15:c='f';break;
}//switch
return c;
}

//this is not function member because need unload di to extern array
//and need unload di to great and small array
template<class T,class Tunit>
DI_INLINE void
di_assignbite(Tunit* dst,const Tunit* src,const T l){
  T i;
  for(i=T();i!=l;++i)  dst[i]=src[i];
}

template<class T,class Tunit>
DI_INLINE void
di_assignbite(Tunit* dst,const Tunit* src,const T l,const T l1){
  T i;
  for(i=T();i!=l;++i)  dst[i]=src[i];
  for(;i!=l1;++i)      dst[i]=Tunit();
}

#define DI_FUN(oper,name)                                                 \
template<class T,class Tunit>                                             \
DI_INLINE void                                                            \
name(Tunit* dst,const Tunit* src,const T l){                              \
  T i;                                                                    \
  for(i=T();i!=l;++i)  dst[i] oper##= src[i];                             \
}                                                                         \
                                                                          \
template<class T,class Tunit>                                             \
DI_INLINE void                                                            \
name(Tunit* dst,const Tunit* src,const T l,const T l1){                   \
  T i;                                                                    \
  for(i=T();i!=l;++i)  dst[i] oper##= src[i];                             \
  for(;i!=l1;++i)      dst[i] oper##= Tunit();                            \
}

DI_FUN(&,di_andbite)
DI_FUN(|,di_orbite)
DI_FUN(^,di_xorbite)

template<class T,class Tunit>
DI_INLINE int
di_comparebite(const Tunit* dshort,const Tunit* dlong,T lenshort,T lenlong){

  T i;
  for(i=lenlong-1;i!=lenshort-1;--i)
  if(dlong[i]!=Tunit()) return 1;

  for(i=lenshort;i!=T();--i){
  T j=i-1;
  if(dlong[j] > dshort[j]) return 1;
  else
  if(dlong[j] < dshort[j]) return -1;
  }//for

return 0;
}

template<class Tunit> inline Tunit di_addunit(bool* cf,const Tunit item1){
Tunit c=item1;

  if(*cf==true){
  ++c;
  if(c==Tunit()) *cf=true; else *cf=false;
  }//if

return c;
}

template<class Tunit>
inline Tunit di_addunit(bool* cf,const Tunit item1,const Tunit item2){
Tunit c=item1+item2;
bool cf1=false;

  if((c<item1)||(c<item2)){
  cf1=true;
  }//if

  if(*cf==true){
  ++c;
  if(c==Tunit()) cf1=true;
  }//if

*cf=cf1;
return c;
}

template<class Tunit> inline Tunit di_subunit(bool* cf,const Tunit item1){
Tunit c=item1;

  if(*cf==true){
  if(c==Tunit()) *cf=true; else *cf=false;
  --c;
  }//if

return c;
}

template<class Tunit>
inline Tunit di_subunit(bool* cf,const Tunit item1,const Tunit item2){
Tunit c=item1-item2;
bool cf1=false;

  if(item2>item1){
  cf1=true;
  }//if

  if(*cf==true){
  if(c==Tunit()) cf1=true;
  --c;
  }//if

*cf=cf1;
return c;
}

template<class Tunit> class di_addfunctor{
public:
static Tunit action(bool* cf,const Tunit item1){return di_addunit(cf,item1);}
static Tunit action(bool* cf,const Tunit item1,const Tunit item2){
return di_addunit(cf,item1,item2);
}
};

template<class Tunit> class di_subfunctor{
public:
static Tunit action(bool* cf,const Tunit item1){return di_subunit(cf,item1);}
static Tunit action(bool* cf,const Tunit item1,const Tunit item2){
return di_subunit(cf,item1,item2);
}
};

template<class T,class Tunit,class functor>
DI_INLINE
bool di_addsub(
Tunit* dst,
const Tunit* src,
const T lendst,
const T lensrc,
const Tunit headmaskdst){

  bool cf=false;

  T i;
  if(lendst<=lensrc){
    for(i=T();i!=lendst-1;++i){
     dst[i]=functor::action(&cf,dst[i],src[i]);
    }//for

    dst[lendst-1]=
    functor::action(
    &cf,
    dst[lendst-1],
    src[lendst-1]&(headmaskdst==Tunit()?~Tunit():headmaskdst));

    if(headmaskdst!=Tunit()){
    if((dst[lendst-1]&(headmaskdst+1))!=Tunit()) cf=true; else cf=false;
    }//if
  }//if
  else{
    for(i=T();i!=lensrc;++i){
    dst[i]=functor::action(&cf,dst[i],src[i]);
    }//for
    for(i=lensrc;i!=lendst;++i){
    if(cf==false) break;
    dst[i]=functor::action(&cf,dst[i]);
    }//for

    if(headmaskdst!=Tunit()){
    if((dst[lendst-1]&(headmaskdst+1))!=Tunit()) cf=true; else cf=false;
    }//if
  }//else
return cf;  
}

template<class T,class Tunit>
inline
bool di_add(Tunit* dst,const Tunit* src,
const Tunit headmaskdst,const T lendst,const T lensrc){
return
di_addsub<T,Tunit,di_addfunctor<Tunit> >(dst,src,lendst,lensrc,headmaskdst);
}

template<class T,class Tunit>
inline
bool di_sub(Tunit* dst,const Tunit* src,
const Tunit headmaskdst,const T lendst,const T lensrc){
return
di_addsub<T,Tunit,di_subfunctor<Tunit> >(dst,src,lendst,lensrc,headmaskdst);
}

template<class T,class Tunit> struct di_unsignedtable1{

Tunit maskarray    [sizeof(Tunit)*CHAR_BIT];
Tunit headmaskarray[sizeof(Tunit)*CHAR_BIT];

//for mul operator
T shift;
Tunit mask;
di_unsignedtable1();
};

template<class T,class Tunit> di_unsignedtable1<T,Tunit>::di_unsignedtable1(){

  T i;
    Tunit m=1;
    for(i=T();i!=sizeof(Tunit)*CHAR_BIT;++i){
    maskarray[i]=m;
    headmaskarray[i]=m>>1;
    if(i!=T()) headmaskarray[i]|=headmaskarray[i-1];
    m<<=1;
    }//for

  shift=(sizeof(Tunit)*CHAR_BIT);
  shift>>=1;
  mask=~Tunit();
  mask>>=shift;

}

template<class T,class Tunit> struct di_unsignedtable{
static const di_unsignedtable1<T,Tunit> table;
};

//static members
template<class T,class Tunit>
const di_unsignedtable1<T,Tunit> di_unsignedtable<T,Tunit>::table;

#define DI_CALCSIZEUNIT(sz)                                               \
(((sz) + (sizeof(Tunit)*CHAR_BIT) - 1)/(sizeof(Tunit)*CHAR_BIT))

#define DI_INITFIELD                                                      \
headmask(table.headmaskarray[size%(sizeof(Tunit)*CHAR_BIT)])

template <bool C,class Tret,class Tret1>
struct di_if{typedef Tret type1;};

template <class Tret,class Tret1>
struct di_if<true,Tret,Tret1>{typedef Tret1 type1;};

template <class T,T size,T size1,class Tret,class Tret1>
struct di_longt{
typedef typename di_if<size1>=size,Tret,Tret1>::type1 type;
};

template<class T,class Tunit,T size> class di_unsigned:
public di_unsignedtable<T,Tunit>{

public:

bool cf;
Tunit headmask;

Tunit array[DI_CALCSIZEUNIT(size)];

template<T size1>
int compare(const di_unsigned<T,Tunit,size1>& d) const {

return (size<=size1)?
-di_comparebite<T,Tunit>
(array,d.array,DI_CALCSIZEUNIT(size),DI_CALCSIZEUNIT(size1))
:
di_comparebite<T,Tunit>
(d.array,array,DI_CALCSIZEUNIT(size1),DI_CALCSIZEUNIT(size));

}

Tunit getheadmask(){return headmask;}

void clearhead(){
if(headmask!=Tunit()) array[DI_CALCSIZEUNIT(size)-1]&=headmask;
}

di_version ver() const {return DI_VERSION;}
di_serialnumber sernum() const {return DI_SN;}

//support function
void clear();
void set();

void clear(const T bit){
array[bit/(sizeof(Tunit)*CHAR_BIT)]&=
~table.maskarray[bit%(sizeof(Tunit)*CHAR_BIT)];
}

void set(const T bit){

array[bit/(sizeof(Tunit)*CHAR_BIT)]|=
table.maskarray[bit%(sizeof(Tunit)*CHAR_BIT)];
}

bool tst(const T bit) const {
if((array[bit/(sizeof(Tunit)*CHAR_BIT)]&
maskarray[bit%(sizeof(Tunit)*CHAR_BIT)])!=Tunit())
return true; else return false;
}

//gets and sets
const T getunit() const {return DI_CALCSIZEUNIT(size);}
const T getbite() const {return size;}

bool getcf() const {return cf;}
bool setcf(const bool c){c1=cf;cf=c;return c1;}

//if do not data alignment these functions will be work properly

//this function must not return reference of Tv because length of Tv may be
//greate then length of di
//therefore it return Tv object
template<class Tv> Tv getval() const {

Tv val=Tv();
  (sizeof(Tv)*CHAR_BIT<=size)?
  di_assignbite<size_t,Tv>(&val,(Tv*)array,1):
  di_assignbite<T,Tunit>((Tunit*)&val,array,DI_CALCSIZEUNIT(size));
  
return val;
}

template<class Tv> di_unsigned&
setval(const Tv& val){return assign<Tv>(&val,1);}

//some casts
const Tunit* c_strunit() const {return (const Tunit*)array;}

operator const Tunit*() const {return c_strunit();}

template<class Tv> operator const Tv() const {return getval<Tv>();}

//intermediate functions
template<class Tunit1>
di_unsigned& assign(const Tunit1* d,const T lengthd){

  T l=DI_CALCSIZEUNIT(size)*sizeof(Tunit);
  T l1=sizeof(Tunit1)*lengthd;
  if(l<=l1)
  di_assignbite<T,unsigned char>((unsigned char*)array,(unsigned char*)d,l);
  else
  di_assignbite<T,unsigned char>((unsigned char*)array,(unsigned char*)d,l1,l);
  return *this;
}

template<T size1>
di_unsigned& assign(const di_unsigned<T,Tunit,size1>& d){

(size<=size1)?
di_assignbite<T,Tunit>(array,d.array,DI_CALCSIZEUNIT(size))
:
di_assignbite<T,Tunit>
(array,d.array,DI_CALCSIZEUNIT(size1),DI_CALCSIZEUNIT(size));

clearhead();

return *this;
}

di_unsigned& assign(const char* c_str);

//destructor do not need because all resource is static allocate 
//virtual ~di_unsigned(){}

//constructors
di_unsigned():
cf(false),
DI_INITFIELD
{
}

di_unsigned(const di_unsigned& d):
cf(d.cf),
DI_INITFIELD
{
this->assign<size>(d);
}

template<T size1>
di_unsigned(const di_unsigned<T,Tunit,size1>& d):
cf(d.cf),
DI_INITFIELD
{
this->assign<size1>(d);
}

template<class Tv> di_unsigned(const Tv& val):
cf(false),
DI_INITFIELD
{
setval<Tv>(val);
}

di_unsigned(const char* c_str):
cf(false),
DI_INITFIELD
{
assign(c_str);
}

di_unsigned(char* c_str):
cf(false),
DI_INITFIELD
{
assign(c_str);
}

//assign operators
di_unsigned& operator = (const di_unsigned& d){
if(this!=(&d)){
  cf=d.cf;
  this->assign<size>(d);
}//if
return *this;
}

template<T size1>
di_unsigned& operator = (const di_unsigned<T,Tunit,size1>& d){
cf=d.cf;
this->assign<size1>(d);
return *this;
}

template<class Tv> di_unsigned& operator = (const Tv& val){
cf=false;
setval<Tv>(val);
return *this;
}
  
di_unsigned& operator = (const char* c_str){
cf=false;
return assign(c_str);
}

di_unsigned& operator = (char* c_str){
cf=false;
return assign(c_str);
}

//binary operators
#define DI_OPERANDASSIGN(op,fun)                                             \
template<T size1>                                                            \
di_unsigned& operator op##= (const di_unsigned<T,Tunit,size1>& d){           \
                                                                             \
  (size<=size1)?                                                             \
  fun<T,Tunit>(array,d.array,DI_CALCSIZEUNIT(size)):                         \
  fun<T,Tunit>(array,d.array,DI_CALCSIZEUNIT(size1),DI_CALCSIZEUNIT(size));  \
  clearhead();                                                               \
return *this;                                                                \
}

DI_OPERANDASSIGN(&,di_andbite)
DI_OPERANDASSIGN(|,di_orbite)
DI_OPERANDASSIGN(^,di_xorbite)

//dividend  - dd (*this)
//divisor   - dv
//quotient  - qu
//remainder - rm
template<T size1>
di_unsigned<T,Tunit,size> div1(const di_unsigned<T,Tunit,size1>& dv,
di_unsigned<T,Tunit,size1>* rm) const;

template<T size1>
di_unsigned<T,Tunit,size+size1>
operator * (const di_unsigned<T,Tunit,size1>& d) const;

template<T size1>
di_unsigned<T,Tunit,size> operator / (const di_unsigned<T,Tunit,size1>& dv)
const{

di_unsigned<T,Tunit,1> zero;
zero.clear();

#ifndef DI_EXCEPTIONENABLE
if(dv==zero){di_unsigned<T,Tunit,size> ret; ret.set();return ret;}
#else
if(dv==zero) throw di_exception;
#endif

di_unsigned<T,Tunit,size1> rm;
return div1<size1>(dv,&rm);
}

template<T size1>
di_unsigned<T,Tunit,size1> operator % (const di_unsigned<T,Tunit,size1>& dv)
const{

di_unsigned<T,Tunit,1> zero;
zero.clear();

#ifndef DI_EXCEPTIONENABLE
if(dv==zero){di_unsigned<T,Tunit,size1> ret; ret.clear();return ret;}
#else
if(dv==zero) throw di_exception;
#endif

di_unsigned<T,Tunit,size1> rm;
div1<size1>(dv,&rm);

return rm;
}

template<T size1>
bool operator != (const di_unsigned<T,Tunit,size1>& d) const {
return !(*this==d);
}

template<T size1>
bool operator == (const di_unsigned<T,Tunit,size1>& d) const {
if(compare<size1>(d)==0) return true; else return false;
}

template<T size1>
bool operator > (const di_unsigned<T,Tunit,size1>& d) const {
return (compare<size1>(d)> 0)?true:false;
}

template<T size1>
bool operator < (const di_unsigned<T,Tunit,size1>& d) const {
return (compare<size1>(d)< 0)?true:false;
}

template<T size1>
bool
operator >= (const di_unsigned<T,Tunit,size1>& d) const {return !(*this<d);}

template<T size1>
bool
operator <= (const di_unsigned<T,Tunit,size1>& d) const {return !(*this>d);}

template<T size1>
di_unsigned& operator += (const di_unsigned<T,Tunit,size1>& d){
cf=di_add<T,Tunit>
(array,d.array,headmask,DI_CALCSIZEUNIT(size),DI_CALCSIZEUNIT(size1));
clearhead();
return *this;
}

template<T size1>
di_unsigned& operator -= (const di_unsigned<T,Tunit,size1>& d){
cf=di_sub<T,Tunit>
(array,d.array,headmask,DI_CALCSIZEUNIT(size),DI_CALCSIZEUNIT(size1));
clearhead();
return *this;
}

#define DI_OPERATOR( op )                                  \
template<T size1>                                          \
di_unsigned operator op (di_unsigned<T,Tunit,size1>& d){   \
di_unsigned r=*this;                                       \
r op##= d;                                                 \
return r;                                                  \
}

DI_OPERATOR(&)
DI_OPERATOR(|)
DI_OPERATOR(^)
DI_OPERATOR(-)

template <T size1>
typename
di_longt<T,size,size1,di_unsigned<T,Tunit,size>,di_unsigned<T,Tunit,size1> >::
type
operator + (const di_unsigned<T,Tunit,size1>& d){
typename
di_longt<T,size,size1,di_unsigned<T,Tunit,size>,di_unsigned<T,Tunit,size1> >::
type r;
r=*this;
r+=d;
return r;
}

#define DI_OPERATOR1( op )                                         \
template<T size1>                                                  \
di_unsigned& operator op##= (const di_unsigned<T,Tunit,size1>& d){ \
*this= (*this) op (d);                                             \
this->clearhead();                                                 \
return *this;                                                      \
}

DI_OPERATOR1(*)
DI_OPERATOR1(/)
DI_OPERATOR1(%)

//unary operators
//prefix
di_unsigned& operator ++ (){
di_unsigned<T,Tunit,1> d;
d.clear();
d.set(0);
*this+=d;
return *this;
}

//postfix
di_unsigned operator ++ (int){
di_unsigned<T,Tunit,1> d;
di_unsigned d1(*this);
d.clear();
d.set(0);
*this+=d;
return d1;
}

//prefix
di_unsigned& operator -- (){
di_unsigned<T,Tunit,1> d;
d.clear();
d.set(0);
*this-=d;
return *this;
}

//postfix
di_unsigned operator -- (int){
di_unsigned<T,Tunit,1> d;
di_unsigned d1(*this);
d.clear();
d.set(0);
*this-=d;
return d1;
}

di_unsigned& operator ~ ();

di_unsigned& operator <<= (const T len){
  if(len>=size){
    clear();
  }//if
  else{

    T c1=len/(sizeof(Tunit)*CHAR_BIT);
    T c2=len%(sizeof(Tunit)*CHAR_BIT);

    if(c1!=T()) leftshiftunit(c1);
    if(c2!=T()) leftshiftbit(c2);

  }//else
clearhead();
return *this;
}

di_unsigned& operator >>= (const T len){
  if(len>=size){
    clear();
  }//if
  else{

    T c1=len/(sizeof(Tunit)*CHAR_BIT);
    T c2=len%(sizeof(Tunit)*CHAR_BIT);

    if(c1!=T()) rightshiftunit(c1);
    if(c2!=T()) rightshiftbit(c2);
  }//else
return *this;
}

di_unsigned operator >> (const T len){
di_unsigned r=*this;
r >>= len;
return r;
}

di_unsigned operator << (const T len){
di_unsigned r=*this;
r <<= len;
return r;
}

//without check numunit and without clearhead
void leftshiftunit(const T numunit);
void rightshiftunit(const T numunit);

void leftshiftbit(const T numbit);
void rightshiftbit(const T numbit);

Tunit gettunit(T index){return array[index];}
void settunit(Tunit data,T index){array[index]=data;}

void printtostring(char* c_str,T lengstr);

};//end class declaration

//support function
template<class T,class Tunit,T size>
DI_INLINE
void di_unsigned<T,Tunit,size>::leftshiftbit(const T numbit){
    T i;
    for(i=T();i!=DI_CALCSIZEUNIT(size);++i){
    array[DI_CALCSIZEUNIT(size)-i-1]<<=numbit;
    if(i!=(DI_CALCSIZEUNIT(size)-1)) array[DI_CALCSIZEUNIT(size)-i-1]|=
    array[DI_CALCSIZEUNIT(size)-i-1-1]>>(sizeof(Tunit)*CHAR_BIT-numbit);
    }//for
}

template<class T,class Tunit,T size>
DI_INLINE
void di_unsigned<T,Tunit,size>::rightshiftbit(const T numbit){
    T i;
    for(i=T();i!=DI_CALCSIZEUNIT(size);++i){
    array[i]>>=numbit;
    if(i!=(DI_CALCSIZEUNIT(size)-1))
    array[i]|=array[i+1]<<(sizeof(Tunit)*CHAR_BIT-numbit);
    }//for
}

template<class T,class Tunit,T size>
DI_INLINE
void di_unsigned<T,Tunit,size>::leftshiftunit(const T numunit){
  T i;

  for(i=numunit;i!=DI_CALCSIZEUNIT(size);++i){
  array[DI_CALCSIZEUNIT(size)-i+numunit-1]=array[DI_CALCSIZEUNIT(size)-i-1];
  }//for

  for(i=T();i!=numunit;++i){
  array[i]=Tunit();
  }//for
}

template<class T,class Tunit,T size>
DI_INLINE
void di_unsigned<T,Tunit,size>::rightshiftunit(const T numunit){
  T i;

  for(i=numunit;i!=DI_CALCSIZEUNIT(size);++i){
  array[i-numunit]=array[i];
  }//for

  for(i=DI_CALCSIZEUNIT(size)-numunit;i!=DI_CALCSIZEUNIT(size);++i){
  array[i]=Tunit();
  }//for
}

template<class T,class Tunit,T size>
DI_INLINE
void di_unsigned<T,Tunit,size>::clear(){
T i;
for(i=T();i!=DI_CALCSIZEUNIT(size);++i) array[i]=Tunit();
}

template<class T,class Tunit,T size>
DI_INLINE
void di_unsigned<T,Tunit,size>::set(){
T i;
for(i=T();i!=DI_CALCSIZEUNIT(size);++i) array[i]=~Tunit();
clearhead();
}

//unary operators
template<class T,class Tunit,T size>
DI_INLINE
di_unsigned<T,Tunit,size>& di_unsigned<T,Tunit,size>::operator ~ (){
T i;
for(i=T();i!=DI_CALCSIZEUNIT(size);++i) array[i]=~array[i];
clearhead();
return *this;
}

template<class T,class Tunit,T size>
DI_INLINE
di_unsigned<T,Tunit,size>&
di_unsigned<T,Tunit,size>::assign(const char* c_str){

clear();

size_t l=sizeof(Tunit)*DI_CALCSIZEUNIT(size);
size_t lenstr;
size_t i;
for(lenstr=0;;++lenstr) if(c_str[lenstr]==0) break;

size_t ii;
for(i=0;i!=lenstr;++i){

ii=i/2;

if(ii==l) break;

unsigned char b;
if(di_char2byte(c_str[lenstr-i-1],&b)==false) break;

  if((i&1)!=0){
  b<<=4;
  ((unsigned char*)array)[ii]|=b;
  }//if
  else{
  ((unsigned char*)array)[ii]=b;
  }//else

}//for

return *this;
}

template<class T,class Tunit,T size>
template<T size1>
DI_INLINE
di_unsigned<T,Tunit,size+size1>
di_unsigned<T,Tunit,size>::operator * (const di_unsigned<T,Tunit,size1>& d)
const{

di_unsigned<T,Tunit,size+size1> res;
di_unsigned<
T,
Tunit,
(sizeof(Tunit)*CHAR_BIT)*(DI_CALCSIZEUNIT(size)+DI_CALCSIZEUNIT(size1))> res1;

res.clear();

T i;
for(i=0;i!=DI_CALCSIZEUNIT(size);++i){
T j;
  for(j=0;j!=DI_CALCSIZEUNIT(size1);++j){

  di_unsigned<T,Tunit,2*(sizeof(Tunit)*CHAR_BIT)> result;
  di_unsigned<T,Tunit,2*(sizeof(Tunit)*CHAR_BIT)> result1;
  di_unsigned<T,Tunit,2*(sizeof(Tunit)*CHAR_BIT)> result2;

  Tunit a1,a2,a3,a4;
  a1=array[i]&table.mask;
  a2=d.array[j]&table.mask;
  a3=array[i]>>table.shift;
  a4=d.array[j]>>table.shift;

  result.settunit(a1*a2,0);
  result.settunit(a3*a4,1);

  result1.settunit(a2*a3,0);
  result2.settunit(a1*a4,0);

  result1.settunit(Tunit(),1);
  result2.settunit(Tunit(),1);

  result1.leftshiftbit(table.shift);
  result2.leftshiftbit(table.shift);

  result+=result1;
  result+=result2;

  res1=result;
  res1.leftshiftunit(i+j);
  res+=res1;
  }//for
}//for

return res;
}

//dividend - dd (*this)
//divisor  - dv
//quotient - qu
//remainder - rm
template<class T,class Tunit,T size>
template<T size1>
DI_INLINE
di_unsigned<T,Tunit,size>
di_unsigned<T,Tunit,size>::div1(const di_unsigned<T,Tunit,size1>& dv,
di_unsigned<T,Tunit,size1>* rm) const{

di_unsigned<T,Tunit,size> dd1=*this;

typename di_longt
<T,size,size1,di_unsigned<T,Tunit,size+1>,di_unsigned<T,Tunit,size1+1> >::
type dv1;

di_unsigned<T,Tunit,size> qu;
di_unsigned<T,Tunit,size+1> qu1;

qu.clear();

for(;;){

  if(dv>dd1){
  *rm=dd1;
  return qu;
  }//if

  dv1=dv;

  qu1.clear();
  qu1.set(0);

    for(;;){
    
    dv1.leftshiftbit(1);
    qu1.leftshiftbit(1);

      if(dv1>dd1){

      dv1.rightshiftbit(1);
      qu1.rightshiftbit(1);

      qu+=qu1;
      dd1-=dv1;

      break;
      }//if
    }//for
}//for

}

template<class T,class Tunit,T size>
DI_INLINE
void di_unsigned<T,Tunit,size>::printtostring(char* c_str,T lengthstr){

if(lengthstr!=0){

  T i;
  T j;
  unsigned char mm=~0;
  mm>>=(CHAR_BIT/2);

  for(j=i=0;i!=DI_CALCSIZEUNIT(size)*sizeof(Tunit);++i){

  unsigned char b=
  ((unsigned char*)array)[DI_CALCSIZEUNIT(size)*sizeof(Tunit)-i-1];

  if(j==(lengthstr-1)) break;
  c_str[j]=di_byte2char(b>>(CHAR_BIT/2));
  ++j;

  if(j==(lengthstr-1)) break;
  c_str[j]=di_byte2char(b&mm);
  ++j;

  }//for

  c_str[j]=0;
  
}//if
}

#endif
