
#include <dit.h>

const time_t di_tmax=1;
const char* di_namerpt="dit.rpt";

const char* dit_errorbase::message[]={
"End programm OK",                        //0
"",                                       //1
"Error in operator",                      //2
"Error in operator carry",                //3
"User break",                             //4
"stop message"
};

template<class T,class Tcounter>
inline void dit_compare1(Tcounter i,T& d,Tcounter maskmax,
Tcounter maskovfl,const char* msg=0){

Tcounter i1=d;
if((i&maskmax)!=i1) throw dit_error<Tcounter>(dit_error2,i,i1,msg);

  if(maskovfl!=0){
    bool fl;
    if((i&maskovfl)!=0) fl=true; else fl=false;
    if(d.getcf()!=fl) throw dit_error<Tcounter>(dit_error3,i,i1,msg);
  }//if
}

#define dit_action1(name,op1,op2,msg)                                         \
template<class T>                                                             \
inline void name(dit_counter i1,dit_counter maskmax1,dit_counter maskovfl1){  \
                                                                              \
dit_counter i0=i1;                                                            \
                                                                              \
T d0=i1;                                                                      \
                                                                              \
dit_counter i10= op1 i0 op2;                                                  \
                                                                              \
T d10= op1 d0 op2;                                                            \
                                                                              \
dit_compare1<T,dit_counter>(i0,d0,maskmax1,maskovfl1,msg);                    \
dit_compare1<T,dit_counter>(i10,d10,maskmax1,maskovfl1,msg);                  \
}

dit_action1(dit_a1,,++,"operator post increment")
dit_action1(dit_a2,++,,"operator pre  increment")
dit_action1(dit_a3,,--,"operator post decrement")
dit_action1(dit_a4,--,,"operator pre  decrement")

template<class T>
inline void dit_a5(dit_counter i1,dit_counter maskmax1){

dit_counter i0=i1;

T d0=i1;

dit_counter i10=~i0;

T d10=d0;
~d10;

dit_compare1<T,dit_counter>(i0,d0,maskmax1,0,"operator negative");
dit_compare1<T,dit_counter>(i10,d10,maskmax1,0,"operator negative");
}

template<class T1>
inline void dit_a6(dit_counter i1,dit_counter maskmax1){

dit_counter k1=i1;
dit_counter k2=i1;
dit_counter k3=i1;
dit_counter k4=i1;
dit_counter k5;
dit_counter k6;

T1 d1=i1;
T1 d2=i1;
T1 d3=i1;
T1 d4=i1;
T1 d5;
T1 d6;

dit_counter ii;
for(ii=0;ii!=d1.getbite()+1+1;++ii){

k1<<=ii;
d1<<=ii;
dit_compare1<T1,dit_counter>(k1,d1,maskmax1,0,"operator L-SHIFT and ASSIGN");

k2>>=ii;
d2>>=ii;
dit_compare1<T1,dit_counter>(k2,d2,maskmax1,0,"operator R-SHIFT and ASSIGN");

k5=k3<<ii;
d5=d3<<ii;
dit_compare1<T1,dit_counter>(k5,d5,maskmax1,0,"operator L-SHIFT");

k6=k4>>ii;
d6=d4>>ii;
dit_compare1<T1,dit_counter>(k5,d5,maskmax1,0,"operator R-SHIFT");

}//for

}

template<class T1>
inline void dit_a7(dit_counter i1,dit_counter maskmax1){

char buf[sizeof(dit_counter)*2+1];
char buf1[sizeof(dit_counter)*2+1];

sprintf(buf,"%x",i1);

T1 d1=buf;
T1 d2;
d2=buf;

dit_compare1<T1,dit_counter>(i1,d1,maskmax1,0,"constructor(char*)");
dit_compare1<T1,dit_counter>(i1,d2,maskmax1,0,"ASSIGN(char*)");

d1.printtostring(buf1,(dit_typecounter)sizeof(dit_counter)*2+1);
dit_counter k1;

sscanf(buf1,"%x",&k1);

dit_compare1<T1,dit_counter>(k1,d2,maskmax1,0,"printtostrinf");
}

template<class T1>
void dit_test1(dit_counter i1,dit_counter maskmax1,dit_counter maskovfl1){

dit_a1<T1>(i1,maskmax1,maskovfl1);
dit_a2<T1>(i1,maskmax1,maskovfl1);
dit_a3<T1>(i1,maskmax1,maskovfl1);
dit_a4<T1>(i1,maskmax1,maskovfl1);
dit_a5<T1>(i1,maskmax1);
dit_a6<T1>(i1,maskmax1);
dit_a7<T1>(i1,maskmax1);

}

#define dit_action2(name,op1,msg,msg1)                                        \
template<class T1,class T2>                                                   \
inline void name(                                                             \
dit_counter i1,                                                               \
dit_counter i2,                                                               \
dit_counter maskmax1,dit_counter maskovfl1,                                   \
dit_counter maskmax2,dit_counter maskovfl2){                                  \
                                                                              \
dit_counter k1=i1;                                                            \
dit_counter k2=i2;                                                            \
dit_counter k3=i1;                                                            \
dit_counter k4=i2;                                                            \
dit_counter k5;                                                               \
                                                                              \
T1 d1=i1;                                                                     \
T2 d2=i2;                                                                     \
T1 d3=i1;                                                                     \
T2 d4=i2;                                                                     \
T1 d5;                                                                        \
                                                                              \
k1 op1##=k2;                                                                  \
d1 op1##=d2;                                                                  \
                                                                              \
dit_compare1<T1,dit_counter>(k1,d1,maskmax1,maskovfl1,msg);                   \
dit_compare1<T2,dit_counter>(k2,d2,maskmax2,maskovfl2,msg);                   \
                                                                              \
k5 =k3 op1 k4;                                                                \
d5 =d3 op1 d4;                                                                \
                                                                              \
dit_compare1<T1,dit_counter>(k5,d5,maskmax1,maskovfl1,msg1);                  \
                                                                              \
}

template<class T1,class T2>
inline void dit_b1(
dit_counter i1,
dit_counter i2,
dit_counter maskmax1,dit_counter maskovfl1,
dit_counter maskmax2,dit_counter maskovfl2){

dit_counter maxmask;
dit_counter maxmaskovfl;
dit_counter minmask;
dit_counter minmaskovfl;

if(maskmax1>maskmax2){
maxmask=maskmax1;
maxmaskovfl=maskovfl1;
minmask=maskmax2;
minmaskovfl=maskovfl2;
}//if
else{
maxmask=maskmax2;
maxmaskovfl=maskovfl2;
minmask=maskmax1;
minmaskovfl=maskovfl1;
}//else

dit_counter k1=i1&minmask;
dit_counter k2=i2&minmask;
dit_counter k3=i1&minmask;
dit_counter k4=i2&minmask;
dit_counter k5;

T1 d1=i1&minmask;
T2 d2=i2&minmask;
T1 d3=i1&minmask;
T2 d4=i2&minmask;

di_longt<dit_typecounter,dit_size,dit_size1,di1_typetest1,di1_typetest2>::type
d5;

k1 +=k2;
d1 +=d2;

dit_compare1<T1,dit_counter>(
k1,d1,maskmax1,maskovfl1,"operator PLUS and ASSIGN");

dit_compare1<T2,dit_counter>(
k2,d2,maskmax2,maskovfl2,"operator PLUS and ASSIGN");

k5 =k3 + k4;
d5 =d3 + d4;

dit_compare1<
di_longt<dit_typecounter,dit_size,dit_size1,di1_typetest1,di1_typetest2>::type,
dit_counter>(k5,d5,maxmask,maxmaskovfl,"operator PLUS");

}

template<class T1,class T2>
inline void dit_b2(
dit_counter i1,
dit_counter i2,
dit_counter maskmax1,dit_counter maskovfl1,
dit_counter maskmax2,dit_counter maskovfl2){

dit_counter maxmask;
dit_counter maxmaskovfl;
dit_counter minmask;
dit_counter minmaskovfl;

if(maskmax1>maskmax2){
maxmask=maskmax1;
maxmaskovfl=maskovfl1;
minmask=maskmax2;
minmaskovfl=maskovfl2;
}//if
else{
maxmask=maskmax2;
maxmaskovfl=maskovfl2;
minmask=maskmax1;
minmaskovfl=maskovfl1;
}//else

dit_counter k1=i1&minmask;
dit_counter k2=i2&minmask;
dit_counter k3=i1&minmask;
dit_counter k4=i2&minmask;
dit_counter k5;

T1 d1=i1&minmask;
T2 d2=i2&minmask;
T1 d3=i1&minmask;
T2 d4=i2&minmask;

T1 d5;

k1 -=k2;
d1 -=d2;

dit_compare1<T1,dit_counter>(
k1,d1,maskmax1,maskovfl1,"operator MINUS and ASSIGN");

dit_compare1<T2,dit_counter>(
k2,d2,maskmax2,maskovfl2,"operator MINUS and ASSIGN");

k5 =k3 - k4;
d5 =d3 - d4;

dit_compare1<T1,dit_counter>(
k5,d5,maskmax1,maskovfl1,"operator MINUS");

}


template<class T1,class T2,class T3>
inline void dit_b6(dit_counter i1,dit_counter i2,dit_counter maskmax1){

dit_longcounter k1=i1*i2;

T1 d1=i1;
T2 d2=i2;
T3 d3=d1*d2;

dit_compare1<T3,dit_longcounter>(k1,d3,~dit_longcounter(),0,"operator MUL");

dit_counter kk1=i1;
dit_counter kk2=i2;

T1 dd1=i1;
T2 dd2=i2;

kk1*=kk2;
dd1*=dd2;

dit_compare1<T1,dit_counter>(kk1,dd1,maskmax1,0,"operator MUL and ASSIGN");
}

#define dit_action3(name,op1,msg)                                             \
template<class T1,class T2>                                                   \
inline void name(dit_counter i1,dit_counter i2){                              \
                                                                              \
bool f1;                                                                      \
if(i1 op1 i2) f1=true; else f1=false;                                         \
                                                                              \
T1 d1=i1;                                                                     \
T2 d2=i2;                                                                     \
                                                                              \
bool f2;                                                                      \
if(d1 op1 d2) f2=true; else f2=false;                                         \
                                                                              \
if(f1!=f2) throw dit_error<dit_counter>(dit_error2,i1,i2,msg);                \
}

dit_action2(dit_b3,^,"operator XOR and ASSIGN","operator XOR")
dit_action2(dit_b4,&,"operator AND and ASSIGN","operator AND")
dit_action2(dit_b5,|,"operator OR and ASSIGN","operator OR")
dit_action2(dit_b7,/,"operator DIV and ASSIGN","operator DIV")
dit_action2(dit_b8,%,"operator % and ASSIGN","operator %")

dit_action3(dit_b9,>,"operator >")
dit_action3(dit_b10,<,"operator <")
dit_action3(dit_b11,>=,"operator >=")
dit_action3(dit_b12,<=,"operator <=")
dit_action3(dit_b13,==,"operator ==")
dit_action3(dit_b14,!=,"operator !=")

template<class T1,class T2,class T3>
void dit_test2(
dit_counter i1,
dit_counter i2,
dit_counter maskmax1,dit_counter maskovfl1,
dit_counter maskmax2,dit_counter maskovfl2){

dit_b1<T1,T2>(i1,i2,maskmax1,maskovfl1,maskmax2,maskovfl2);

dit_b2<T1,T2>(i1,i2,maskmax1,maskovfl1,maskmax2,maskovfl2);
dit_b3<T1,T2>(i1,i2,maskmax1,0,maskmax2,0);
dit_b4<T1,T2>(i1,i2,maskmax1,0,maskmax2,0);
dit_b5<T1,T2>(i1,i2,maskmax1,0,maskmax2,0);
dit_b6<T1,T2,T3>(i1,i2,maskmax1);

if(i2!=0){
dit_b7<di1_typetest1,di1_typetest2>
(i1,i2,maskmax1,maskovfl1,maskmax2,maskovfl2);

dit_b8<di1_typetest1,di1_typetest2>
(i1,i2,maskmax1,maskovfl1,maskmax2,maskovfl2);

}//if

dit_b9<T1,T2>(i1,i2);
dit_b10<T1,T2>(i1,i2);
dit_b11<T1,T2>(i1,i2);
dit_b12<T1,T2>(i1,i2);

}

void dit_printi(FILE* f,dit_counter i1,dit_counter i2){
fprintf(f,"\ni1=%u i2=%u ",i1,i2);
}

int main(){

FILE* fl=fopen(di_namerpt,"wt");
rewind(fl);
fclose(fl);

dit_counter i1;
dit_counter i2;

time_t tprev=time(0);

di1_typetest1 mask1;
mask1.set();
dit_counter maskmax1=mask1;
dit_counter maskovfl1=maskmax1+1;

di1_typetest2 mask2;
mask2.set();
dit_counter maskmax2=mask2;
dit_counter maskovfl2=maskmax2+1;

printf("\nTest for di_unsigned");
printf("\n\
Create by MKTMK. Moscow, Russia. 24.oct.2003 (Last modif. 14.aug.2004)");

printf("\nVersion:%3.2f",((float)DI_VERSION)/100);
printf("\nSize=%u Size1=%u",dit_size,dit_size1);

#ifdef __Borland__
printf("\nPress ESC for break");
#endif

time_t tstart=time(0);
printf("\n");
printf("\nstart time=%s",ctime(&tstart));

char ts[100];

try{

di_unsigned<dit_typecounter,dit_typeunit,100> hhh;

hhh=0x010203;

char gg[3];

hhh.printtostring(gg,3);

  for(i1=dit_counter();i1<maskovfl1;++i1){

      dit_test1<di1_typetest1>(i1,maskmax1,maskovfl1);

      for(i2=dit_counter();i2<maskovfl2;++i2){

      time_t tcurrent=time(0);

      static dit_counter printcount=0;

      if((tcurrent-tprev)>=di_tmax){

      strcpy(ts,ctime(&tcurrent));
      ts[strlen(ts)-1]=0;

      ++printcount;
      printf("\r                                                            ");
      printf("\r%u. i1=%u i2=%u time=%s",printcount,i1,i2,ts);

      tprev=tcurrent;
      
#ifdef __Borland__

      for(;;){
        if(kbhit()!=0){
        if(getch()==0x1b) throw dit_errorbase(dit_error4);
        }//if
        else{
        break;
        }//else
      }//for

#endif

      }//if

      dit_test2<di1_typetest1,di1_typetest2,di1_typetest3>
      (i1,i2,maskmax1,maskovfl1,maskmax2,maskovfl2);

      }//for i2
  }//for i1

throw dit_errorbase(dit_error0);

}//try

catch(dit_errorbase& err){
err.release(stdout);
FILE* fl=fopen(di_namerpt,"wt");
err.release(fl);
dit_printi(fl,i1,i2);
fclose(fl);

time_t tstop=time(0);
printf("\n");
printf("stop time=%s",ctime(&tstop));
dit_printi(stdout,i1,i2);

return err.geterror();
}//catch

}

